using System;
using System.IO;
using ET199ComLib;
using System.Runtime.InteropServices;

namespace ET199ComSample
{
    class Program
    {
        static void Main(string[] args)
        {
            ET199 et = null;
            int lBytesReturn;
            object objNull = null;
            try
            {
                System.Console.WriteLine("ET199 test begin...");

                et = new ET199();
                //(1)ö豸
                System.Console.WriteLine("ö豸...");
                int nDevCount = et.Enum();
                System.Console.WriteLine("{0}",nDevCount);
                if(nDevCount == 0)
                {
                    return;
                }
                //(2)豸0
                System.Console.WriteLine("\n豸0...");
                et.Open(0);
                //ʾ豸Ϣ
                DisplayDeviceInfo(et);

                object objDevPinOrigin = new byte[24] 
                {
                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
                };
                try
                {
                    //(3)лĿ¼
                    System.Console.WriteLine("\nлĿ¼...");
                    et.ChangeDir("\\");
                    //(4)֤pin
                    System.Console.WriteLine("\n֤pin...");
                    et.VerifyPin(ref objDevPinOrigin, ET_PIN_TYPE.ET_DEV_PIN);
                    //(5)ɾĿ¼
                    System.Console.WriteLine("\nɾĿ¼...");
                    et.EraseDir(null);
                }
                catch(COMException e)
                {
                    if (e.ErrorCode == (int)ET_ERROR_TYPE.ET_E_DIR_NOT_FOUND)//Ŀ¼
                    {
                        System.Console.WriteLine("ET199 exception:{0}", et.FormatErrorMessage(e.ErrorCode));
                    }
                    else//
                    {
                        throw e;
                    }
                }
                //(6)Ŀ¼
                System.Console.WriteLine("\nĿ¼...");
                et.CreateDir("\\", 0, ET_DIR_TYPE.ET_ROOT_DIR);

                //(7)֤pin
                System.Console.WriteLine("\n֤pin...");
                et.VerifyPin(ref objDevPinOrigin, ET_PIN_TYPE.ET_DEV_PIN);

                //(8)LED˸
                int nLedFreq = 5;
                object objLedFreq = new byte[4] { (byte)nLedFreq, 0, 0, 0 };
                System.Console.WriteLine("\nLED˸ƵΪ{0}...", nLedFreq);
                et.Control(ET_CONTROL_TYPE.ET_LED_WINK, ref objLedFreq, 4, ref objNull, out lBytesReturn);               

                //(9)Ŀ¼
                string strSubDirID = "5678";
                System.Console.WriteLine("\nĿ¼,IDΪ{0}...",strSubDirID);
                et.CreateDir(strSubDirID, 0x2000, ET_DIR_TYPE.ET_SUB_DIR);

                //(10)Ŀpin
                System.Console.WriteLine("\nĿpin...");
                object objDevPinNew = new byte[24]
                {
                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31
                };
                et.ChangePin(ref objDevPinOrigin, ref objDevPinNew, ET_PIN_TYPE.ET_DEV_PIN, 0xff);

                //(11)һִļ
                string strExeFileID = "1234";
                System.Console.WriteLine("\nһִļ,IDΪ{0}...", strExeFileID);
                et.CreateFile(strExeFileID, 0x1000, 0);

                //(12)дݵִļ
                System.Console.WriteLine("\nдݵִļ{0}...", strExeFileID);
                WriteExeFileData(et, strExeFileID, "..\\..\\hardware\\hardware.bin");

                //(13)֤ûpin
                System.Console.WriteLine("\n֤ûpin...");
                object objUserPin = new byte[8]
                {
                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
                };
                et.VerifyPin(ref objUserPin, ET_PIN_TYPE.ET_USER_PIN);

                //(14)пִг
                System.Console.WriteLine("\nпִг{0}...", strExeFileID);
                object objOutBuffer = new byte[4] { 1, 2, 3, 4 };
                et.Execute(strExeFileID, ref objNull, 0, ref objOutBuffer, out lBytesReturn);

                //(15)ȡļϢ
                System.Console.WriteLine("\nȡļϢ...");
                object objFileinfo = new byte[5] 
                {
                    0x31,0x32,0x33,0x34,0x00
                };
                et.Control(ET_CONTROL_TYPE.ET_GET_EF_INFO, ref objFileinfo, 4, ref objFileinfo, out lBytesReturn);

                //(16)֤pin
                System.Console.WriteLine("\n֤pin...");
                et.VerifyPin(ref objDevPinNew, ET_PIN_TYPE.ET_DEV_PIN);

                //(17)Կ
                System.Console.WriteLine("\nRSAԿ...");
                object objPubKeyData = new byte[0x400];
                object objPriKeyData = new byte[0x400];
                et.GenerateRsaKey(1024, 0x10001, "1111", "2222",ref objPubKeyData,ref objPriKeyData);

                //(18)лһĿ¼
                System.Console.WriteLine("\nлһĿ¼...");
                et.ChangeDir("..");

                //(19)豸
                System.Console.WriteLine("\n豸...");
                et.Control(ET_CONTROL_TYPE.ET_RESET_DEVICE, ref objNull, 0, ref objNull, out lBytesReturn);

                //(20)֤pin
                System.Console.WriteLine("\n֤pin...");
                et.VerifyPin(ref objDevPinOrigin, ET_PIN_TYPE.ET_DEV_PIN);

                //(21)ɾĿ¼
                System.Console.WriteLine("\nɾĿ¼...");
	            et.EraseDir(null);

                //(22)Ŀ¼
                System.Console.WriteLine("\nĿ¼...");
                et.CreateDir("\\", 0, ET_DIR_TYPE.ET_ROOT_DIR);

                //(23)ر豸
                System.Console.WriteLine("\nر豸...");
	            et.Close();

                System.Console.WriteLine("\nET199 test end");
            }
            catch(COMException e)
            {
                System.Console.WriteLine("ET199 exception:{0}", et.FormatErrorMessage(e.ErrorCode));
            }
            catch(Exception e)
            {
                System.Console.WriteLine(e.ToString());
            }
            System.Console.ReadKey();
        }
        static void WriteExeFileData(ET199 et,string strFileID,string strFilePath)
        {
            FileStream fs = File.OpenRead(strFilePath);
            if(fs.Length > 10240)
            {
                throw new Exception("File too large");
            }
            byte[] byBuf = new byte[fs.Length];
            fs.Read(byBuf,0,(int)fs.Length);       
            object buf = byBuf;
            et.WriteFile(strFileID, 0, ref buf, (int)fs.Length);
        }
        static void DisplayDeviceInfo(ET199 et)
        {
	        
            System.Console.Write("Version:\t{0}.", et.Version/256);
            System.Console.WriteLine("{0:d02}", (byte)et.Version);
            
            System.Console.WriteLine("Customer:\t{0:x08}\t", et.Customer);

            String str = System.Text.Encoding.ASCII.GetString((byte[])et.Atr);
            System.Console.WriteLine("ATR:\t\t{0}",str);

            byte[] byID = (byte[])et.ID;
            System.Console.WriteLine("ID:\t\t{0:x02}{1:x02}{2:x02}{3:x02}{4:x02}{5:x02}{6:x02}{7:x02}",
                byID[7],byID[6],byID[5],byID[4],byID[3],byID[2],byID[1],byID[0]);
        }
    }
}
