﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {

        [DllImport("ET199_32.dll")]
        public static extern uint ETEnum(byte[] pETContextList, ref uint dwET199Count);

        [DllImport("ET199_32.dll")]
        public static extern uint ETOpen(byte[] pETContextList);

        [DllImport("ET199_32.dll")]
        public static extern uint ETClose(byte[] pETContextList);

        [DllImport("ET199_32.dll")]
        public static extern uint ETVerifyPin(byte[] pETContextList, byte[] pbPin, uint dwPinLen, uint dwPinType);
       
        
        [DllImport("ET199_32.dll")]
        public static extern uint ETChangePin(byte[] pETContextList, byte[] pbOldPin, uint dwOldPinLen, byte[] pbNewPin, uint dwNewPinLen, uint dwPinType, byte byPinTryCount);

        
        [DllImport("ET199_32.dll")]
        public static extern uint ETExecute(byte[] pETContextList, byte[] lpszFileID, byte[] pInBuffer, uint dwInbufferSize, byte[] pOutBuffer, uint dwOutBufferSize, ref uint pdwBytesReturned);

        [DllImport("ET199_32.dll")]
        public static extern uint ETControl(byte[] pETContextList, uint dwCtlCode, byte[] pInBuffer, uint dwInbufferSize, byte[] pOutBuffer, uint dwOutBufferSize, ref uint pdwBytesReturned);

        
        
        [DllImport("RSAEnc.dll")]
        public static extern uint RSAData(byte[] pbPubKey, uint ulPubKeyLen, byte[] pbData, uint ulDataLen);

    

        public Form1()
        {
            InitializeComponent();
        }

        public string byteToHexString(byte[] byTemp, int len)
        {
            string strtemp = "";
            for (int j = 0; j < len; j++)
            {
  
                  strtemp += string.Format("{0}", byTemp[j].ToString("X"));
            }
            return strtemp;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] pbPubKey = new byte[128] 
            {
                0xB4, 0x51, 0x64, 0x1C, 0x39, 0xC7, 0x8F, 0x51, 0xB5, 0x36, 0x30, 0xA1, 0x7F, 0xBE, 0x70, 0xB0,
		        0xBE, 0x3A, 0x87, 0x3F, 0x78, 0x50, 0x20, 0x57, 0xFD, 0xDB, 0xD7, 0x6B, 0x6E, 0x4B, 0x9E, 0x3A,
		        0xE7, 0x8A, 0xA5, 0x8F, 0x7A, 0x51, 0x22, 0x4A, 0xC3, 0x64, 0x5D, 0x84, 0xA7, 0xB2, 0x10, 0xE1,
		        0x1B, 0x32, 0x67, 0x95, 0x1F, 0xB4, 0x62, 0x71, 0x8A, 0xA6, 0x3D, 0x35, 0x9B, 0x52, 0xC5, 0x4A,
		        0x2A, 0xA2, 0x86, 0xB2, 0x55, 0x13, 0x90, 0xDB, 0x5A, 0x0E, 0xE0, 0xA4, 0x71, 0x0C, 0x09, 0xF6,
		        0x3B, 0x21, 0x95, 0x35, 0x29, 0xC4, 0x7E, 0xF8, 0x3B, 0xA9, 0x6C, 0x4E, 0x61, 0xC8, 0x84, 0x79,
		        0xDC, 0x8F, 0x5F, 0x0E, 0x1B, 0xE2, 0xF8, 0x72, 0xC2, 0x46, 0x25, 0x21, 0x03, 0xBE, 0x1A, 0x80,
		        0x6A, 0xAA, 0x17, 0x37, 0xCE, 0x19, 0x9D, 0x14, 0x49, 0x98, 0xE2, 0x98, 0x16, 0x3C, 0x3A, 0xB9
            };


            byte[] pbPlain = new byte[128];
            for (int i = 0; i < 128; ++i)
            {
                pbPlain[i] = (byte)i;
            }

            //软件中使用公钥加密数据
            long ret = RSAData(pbPubKey, 1024, pbPlain, 128);//第三个参数输入数据，返回结果

            if (ret != 0)
            {
 
                richTextBox1.SelectedText = "pubkey encrypt fail:" + ret.ToString() + "\r\n\r\n";
 
            }
            else
            {
                String strpubenc;
                strpubenc = byteToHexString(pbPlain, 128);
                richTextBox1.SelectedText = "软件中使用公钥加密数据sucess:" + strpubenc + "\r\n\r\n";
  
            }

            uint dwRet = 0;
            uint dwET199Count = 0;
            
            //硬件中使用私钥解密
            dwRet = ETEnum(null, ref dwET199Count);
            if ((dwRet != 0xf0000004) && (dwRet != 0))  //0xF0000004 = ET_E_INSUFFICIENT_BUFFER
            {
                richTextBox1.SelectedText = "ETEnum 1 fail:"+dwRet.ToString("X")+"\r\n\r\n";
                return;
            }

            byte[] pET199 = new byte[56 * dwET199Count]; //sizeof(ET_CONTEXT)=56

            dwRet = ETEnum(pET199, ref dwET199Count);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETEnum 2 fail:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }


            dwRet = ETOpen(pET199);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETOpen:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }

            byte[] pUserPin = new byte[8]
            {
                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
            };

            dwRet = ETVerifyPin(pET199, pUserPin, 8, 0);//ET_USER_PIN	0x00000000 
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETVerifyPin:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }

            byte[] pATRData = new byte[16];
            uint uETControllen = 0;

            dwRet = ETControl(pET199, 0x00000014, null, 0, pATRData, 16, ref uETControllen);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETExecute:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }
            else
            {
                String stratr;
                stratr = byteToHexString(pATRData, 16);
                richTextBox1.SelectedText = "ATR sucess:" + stratr + "\r\n\r\n";
            }

            byte[] pFileID = new byte[4]
            {
                    0x30, 0x30, 0x30, 0x31
            };

            byte[] pbPriDec = new byte[128];
            uint uRetlen = 0;

            dwRet = ETExecute(pET199, pFileID, pbPlain, 128, pbPriDec, 128, ref uRetlen);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETExecute:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }
            else
            {
                String strpridec;
                strpridec = byteToHexString(pbPriDec, 128);
                richTextBox1.SelectedText = "硬件中使用私钥解密 sucess:" + strpridec + "\r\n\r\n";
            }
            
            ETClose(pET199);


            //硬件中使用私钥加密
            for (int i = 0; i < 128; ++i)
            {
                pbPlain[i] = (byte)i;
            }



            dwRet = ETEnum(pET199, ref dwET199Count);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETEnum 2 fail:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }


            dwRet = ETOpen(pET199);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETOpen:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }

      
            dwRet = ETVerifyPin(pET199, pUserPin, 8, 0);//ET_USER_PIN	0x00000000 
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETVerifyPin:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }

    
            byte[] pbPriEec = new byte[128];

            dwRet = ETExecute(pET199, pFileID, pbPlain, 128, pbPriEec, 128, ref uRetlen);
            if (dwRet != 0)
            {
                richTextBox1.SelectedText = "ETExecute:" + dwRet.ToString("X") + "\r\n\r\n";
                return;
            }
            else
            {
                String strprienc;
                strprienc = byteToHexString(pbPriEec, 128);
                richTextBox1.SelectedText = "硬件中使用私钥加密sucess:" + strprienc + "\r\n\r\n";
            }

            ETClose(pET199);


            //软件中使用公钥解密
            ret = RSAData(pbPubKey, 1024, pbPriEec, 128); //第三个参数输入数据，返回结果
            if (ret != 0)
            {

                richTextBox1.SelectedText = "pubkey decrypt fail:" + ret.ToString() + "\r\n\r\n";

            }
            else
            {
                String strpubdec;
                strpubdec = byteToHexString(pbPriEec, 128);
                richTextBox1.SelectedText = "软件中使用公钥解密sucess:" + strpubdec + "\r\n\r\n";

            }        

           
            
        }
    }
}